'Test of the DS1307 Unix time driver
'Copyright 2007 Raymond Allen

CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency


OBJ  'Objects Section
    'We need the VGA (or TV) text driver
    
 text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).
 ds1307 : "DS1307_Driver" 


PUB MAIN|i    'the first PUB routine is assumed the be the main one
  
  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video


   'set test time 
   TimeTest(1)
  

  'show time
   repeat  
     text.str(string($B,$2,$A))
     text.out(0)
     'get time
     if (NOT ds1307.time)
       text.str(string("Error Reading DS1307 RTC.",13))
       quit
     text.str(String("Local Time",13))  
     text.str(ds1307.StrTime(1))
     text.out(13)
     text.out(13)
     text.str(String("Unix Time",13))  
     text.str(ds1307.StrTime(2))
     text.out(13)
     text.out(13)
     text.str(String("C Time",13))  
     text.str(ds1307.StrTime(3))
     text.out(13)

Pub TimeTest(n)|zone
  'Examples (or tests...):
  'set time zone
  zone:=5    '5==USA\New York .. 8==USA\Los Angeles
  ds1307.SetTimeZone(zone)
  text.out(0)
  Case n
    1:
      'just before DST starts
      text.str(string("Just before DST Started:"))
      ds1307.SetLocalTime(3, 11, 2007, 1, 59, 50)  '(month, day, year, hours, minutes,seconds)
    2:
      'just after DST starts
      text.str(string("Just after DST Started:"))
      ds1307.SetLocalTime(3, 11, 2007, 3, 01, 00)  '(month, day, year, hours, minutes,seconds)
    3:
      'just before DST ends  'Hard to set this because this hour exists twice!
      text.str(string("Just before DST ends:"))
        'First, set two hours before ends
      ds1307.SetLocalTime(11, 4, 2007, 0, 59, 50)  '(month, day, year, hours, minutes,seconds)
        'Then, add two hours
      ds1307.SetUnixTime(ds1307.time+ds1307#secondsperhour*2)
    4:
      'Setting a time in GMT via data/time
      'GMT:  Sun, 11 Mar 2007 00:59:50 UTC
      text.str(string("Some day in March:"))
      ds1307.SetGmtTime(3,11,2007,0,59,50)  '(month, day, year, hours, minutes,seconds)
    5: 
      'Setting a time in GMT via unix time
      text.str(string("Testing Day:"))
      ds1307.SetUnixTime(1196100282)
    6:
      'Last month, day, hour
      text.str(string("Lasts:"))
      ds1307.SetUnixTime(1198972790)
      ds1307.SetUnixTime(ds1307.time+ds1307#secondsperhour*zone)   'assuming EST
    7:
     'End of year
      text.str(string("New Year:"))
      ds1307.SetUnixTime(1199145590)
      ds1307.SetUnixTime(ds1307.time+ds1307#secondsperhour*zone)   'assuming EST
    8:
      'Y2K38 Problem
      text.str(string("Year 2038 Problem"))
      ds1307.SetUnixTime($7FFF_FFFA) 'This actually keeps going!  But, try to set a date in 2038!
    9:
      'UTC 1234567890
      text.str(string("UTC 1234567890"))
      ds1307.SetUnixTime(1234567880)
    10:
      'UTC 2000000000
      text.str(string("Second Billennium"))
      ds1307.SetUnixTime(1999999990)            
        
      
      
       
           